diff --git a/app/models/medium.rb b/app/models/medium.rb
index ddc552e20..5b96e86ee 100644
--- a/app/models/medium.rb
+++ b/app/models/medium.rb
@@ -1,5 +1,5 @@
 class Medium < ActiveRecord::Base
-  include Authorization
+  include Authorizable
   include Taxonomix
   include ValidateOsFamily
   audited :allow_mass_assignment => true
diff --git a/app/models/model.rb b/app/models/model.rb
index 75280fa43..6a1f289a2 100644
--- a/app/models/model.rb
+++ b/app/models/model.rb
@@ -1,5 +1,5 @@
 class Model < ActiveRecord::Base
-  include Authorization
+  include Authorizable
 
   has_many_hosts
   has_many :trends, :as => :trendable, :class_name => "ForemanTrend"
diff --git a/app/models/operatingsystem.rb b/app/models/operatingsystem.rb
index c1fc884ac..30deccfdb 100644
--- a/app/models/operatingsystem.rb
+++ b/app/models/operatingsystem.rb
@@ -2,7 +2,7 @@ require 'ostruct'
 require 'uri'
 
 class Operatingsystem < ActiveRecord::Base
-  include Authorization
+  include Authorizable
   include ValidateOsFamily
 
   before_destroy EnsureNotUsedBy.new(:hosts, :hostgroups)
diff --git a/app/models/parameter.rb b/app/models/parameter.rb
index 2c5a7f4ac..7dbe9e7ff 100644
--- a/app/models/parameter.rb
+++ b/app/models/parameter.rb
@@ -1,6 +1,6 @@
 class Parameter < ActiveRecord::Base
   belongs_to_host :foreign_key => :reference_id
-  include Authorization
+  include Authorizable
 
   validates :value, :presence => true
   validates :name, :presence => true, :format => {:with => /\A\S*\Z/, :message => N_("can't contain white spaces")}
diff --git a/app/models/parameters/domain_parameter.rb b/app/models/parameters/domain_parameter.rb
index a72fced77..45c2b9090 100644
--- a/app/models/parameters/domain_parameter.rb
+++ b/app/models/parameters/domain_parameter.rb
@@ -2,21 +2,4 @@ class DomainParameter < Parameter
   belongs_to :domain, :foreign_key => :reference_id
   audited :except => [:priority], :associated_with => :domain, :allow_mass_assignment => true
   validates :name, :uniqueness => {:scope => :reference_id}
-
-  private
-  def enforce_permissions operation
-    # We get called again with the operation being set to create
-    return true if operation == "edit" and new_record?
-
-    current = User.current
-
-    if current.allowed_to?("#{operation}_domains".to_sym)
-      if current.domains.empty? or current.domains.include? domain
-        return true
-      end
-    end
-
-    errors.add(:base, _("You do not have permission to %s this domain parameter") % operation)
-    false
-  end
 end
diff --git a/app/models/parameters/group_parameter.rb b/app/models/parameters/group_parameter.rb
index ce3a8de59..ceaedfc48 100644
--- a/app/models/parameters/group_parameter.rb
+++ b/app/models/parameters/group_parameter.rb
@@ -3,20 +3,4 @@ class GroupParameter < Parameter
   audited :except => [:priority], :associated_with => :hostgroup, :allow_mass_assignment => true
   validates :name, :uniqueness => {:scope => :reference_id}
 
-  private
-  def enforce_permissions operation
-    # We get called again with the operation being set to create
-    return true if operation == "edit" and new_record?
-
-    current = User.current
-
-    if current.allowed_to?("#{operation}_params".to_sym)
-      if current.hostgroups.empty? or current.hostgroups.include? hostgroup
-        return true
-      end
-    end
-
-    errors.add(:base, _("You do not have permission to %s this group parameter") % operation)
-    false
-  end
 end
diff --git a/app/models/parameters/host_parameter.rb b/app/models/parameters/host_parameter.rb
index 1b3fdb52c..165be6ae4 100644
--- a/app/models/parameters/host_parameter.rb
+++ b/app/models/parameters/host_parameter.rb
@@ -7,14 +7,4 @@ class HostParameter < Parameter
     "#{host.id ? host.name : "unassociated"}: #{name} = #{value}"
   end
 
-  private
-  def enforce_permissions operation
-    # We get called again with the operation being set to create
-    return true if operation == "edit" and new_record?
-
-    (auth = User.current.allowed_to?("#{operation}_params".to_sym)) and Host.my_hosts.include?(host)
-
-    errors.add(:base, _("You do not have permission to %s this domain") % operation) unless auth
-    auth
-  end
 end
diff --git a/app/models/parameters/os_parameter.rb b/app/models/parameters/os_parameter.rb
index 8ba30ff89..2e259e4d5 100644
--- a/app/models/parameters/os_parameter.rb
+++ b/app/models/parameters/os_parameter.rb
@@ -3,14 +3,4 @@ class OsParameter < Parameter
   audited :except => [:priority], :associated_with => :operatingsystem, :allow_mass_assignment => true
   validates :name, :uniqueness => {:scope => :reference_id}
 
-  private
-  def enforce_permissions operation
-    # We get called again with the operation being set to create
-    return true if operation == "edit" and new_record?
-    return true if User.current.allowed_to?("#{operation}_operatingsystems".to_sym)
-
-    errors.add(:base, _("You do not have permission to %s this Operating System parameter") % operation)
-    false
-  end
-
 end
diff --git a/app/models/permission.rb b/app/models/permission.rb
new file mode 100644
index 000000000..b5f86ca04
--- /dev/null
+++ b/app/models/permission.rb
@@ -0,0 +1,20 @@
+class Permission < ActiveRecord::Base
+  attr_accessible :name, :resource_type
+
+  validates :name, :presence => true, :uniqueness => { :scope => :resource_type }
+
+  has_many :filterings, :dependent => :destroy
+  has_many :filters, :through => :filterings
+
+  def self.resources
+    @all_resources ||= Permission.uniq.order(:resource_type).pluck(:resource_type).compact
+  end
+
+  def self.resources_with_translations
+    with_translations.sort { |a, b| a.first <=> b.first }
+  end
+
+  def self.with_translations
+    resources.map { |r| [_(Filter.get_resource_class(r).try(:humanize_class_name) || r), r] }
+  end
+end
diff --git a/app/models/ptable.rb b/app/models/ptable.rb
index ee0a55926..461786ccd 100644
--- a/app/models/ptable.rb
+++ b/app/models/ptable.rb
@@ -3,7 +3,7 @@
 # A host object may contain a reference to one of these ptables or, alternatively, it may contain a
 # modified version of one of these in textual form
 class Ptable < ActiveRecord::Base
-  include Authorization
+  include Authorizable
   include ValidateOsFamily
   audited :allow_mass_assignment => true
 
diff --git a/app/models/puppetclass.rb b/app/models/puppetclass.rb
index f953e3dc7..1fe9282ab 100644
--- a/app/models/puppetclass.rb
+++ b/app/models/puppetclass.rb
@@ -1,5 +1,5 @@
 class Puppetclass < ActiveRecord::Base
-  include Authorization
+  include Authorizable
   before_destroy EnsureNotUsedBy.new(:hosts, :hostgroups)
   has_many :environment_classes, :dependent => :destroy
   has_many :environments, :through => :environment_classes, :uniq => true
diff --git a/app/models/report.rb b/app/models/report.rb
index 8ea60fdc4..4f924f0f2 100644
--- a/app/models/report.rb
+++ b/app/models/report.rb
@@ -1,5 +1,5 @@
 class Report < ActiveRecord::Base
-  include Authorization
+  include Authorizable
   include ReportCommon
 
   belongs_to_host
@@ -33,7 +33,8 @@ class Report < ActiveRecord::Base
   # returns reports for hosts in the User's filter set
   scope :my_reports, lambda {
     unless User.current.admin? and Organization.current.nil? and Location.current.nil?
-      where(:reports => {:host_id => Host.my_hosts.select("hosts.id")})
+      host_ids = Host.authorized(:view_hosts, Host).select("hosts.id").all
+      where(:reports => {:host_id => host_ids})
     end
   }
 
@@ -171,18 +172,6 @@ class Report < ActiveRecord::Base
 
   private
 
-  def enforce_permissions operation
-    # No one can edit a report
-    return false if operation == "edit"
-
-    # Anyone can create a report
-    return true if operation == "create"
-    return true if operation == "destroy" and User.current.allowed_to?(:destroy_reports)
-
-    errors.add(:base, _("You do not have permission to %s this report") % operation)
-    false
-  end
-
   # puppet report status table column name
   def self.report_status
     "status"
diff --git a/app/models/role.rb b/app/models/role.rb
index c24a47b29..bfbc1e37b 100644
--- a/app/models/role.rb
+++ b/app/models/role.rb
@@ -31,12 +31,17 @@ class Role < ActiveRecord::Base
   before_destroy :check_deletable
 
   has_many :user_roles, :dependent => :destroy
-  has_many :users, :through => :user_roles
+  has_many :users, :through => :user_roles, :source => :owner, :source_type => 'User'
+  has_many :usergroups, :through => :user_roles, :source => :owner, :source_type => 'Usergroup'
+  has_many :cached_user_roles, :dependent => :destroy
+  has_many :cached_users, :through => :cached_user_roles, :source => :user
 
-  serialize :permissions, Array
+  has_many :filters, :dependent => :destroy
+
+  has_many :permissions, :through => :filters
   attr_protected :builtin
 
-  validates :name, :presence => true, :uniqueness => true,  :length => {:maximum => 30}, :format => {:with => /\A\w[\w\s\'\-]*\w\Z/i}
+  validates :name, :presence => true, :uniqueness => true, :format => {:with => /\A\w[\w\s\'\-]*\w\Z/i}
   validates :builtin, :inclusion => { :in => 0..2 }
 
   scoped_search :on => :name, :complete_value => true
@@ -46,36 +51,13 @@ class Role < ActiveRecord::Base
     self.builtin = 0
   end
 
-  def permissions
-    read_attribute(:permissions) || []
-  end
-
-  def permissions=(perms)
-    perms = perms.collect {|p| p.to_sym unless p.blank? }.compact.uniq if perms
-    write_attribute(:permissions, perms)
-  end
-
-  def add_permission!(*perms)
-    self.permissions = [] unless permissions.is_a?(Array)
-
-    permissions_will_change!
-    perms.each do |p|
-      p = p.to_sym
-      permissions << p unless permissions.include?(p)
-    end
-    save!
-  end
-
-  def remove_permission!(*perms)
-    return unless permissions.is_a?(Array)
-    permissions_will_change!
-    perms.each { |p| permissions.delete(p.to_sym) }
-    save!
-  end
-
   # Returns true if the role has the given permission
   def has_permission?(perm)
-    !permissions.nil? && permissions.include?(perm.to_sym)
+    permission_names.include?(perm.to_sym)
+  end
+
+  def permission_names
+    @permission_names ||= permissions.map { |p| p.name.to_sym }
   end
 
   # Return true if the role is a builtin role
@@ -94,19 +76,13 @@ class Role < ActiveRecord::Base
   # * a permission Symbol (eg. :edit_project)
   def allowed_to?(action)
     if action.is_a? Hash
+      action[:controller] = action[:controller][1..-1] if action[:controller].starts_with?('/')
       allowed_actions.include? "#{action[:controller]}/#{action[:action]}"
     else
       allowed_permissions.include? action
     end
   end
 
-  # Return all the permissions that can be given to the role
-  def setable_permissions
-    setable_permissions  = Foreman::AccessControl.permissions - Foreman::AccessControl.public_permissions
-    setable_permissions -= Foreman::AccessControl.loggedin_only_permissions if self.builtin == BUILTIN_ANONYMOUS
-    setable_permissions
-  end
-
   # Find all the roles that can be given to a user
   def self.find_all_givable
     all(:conditions => {:builtin => 0}, :order => 'name')
@@ -138,9 +114,35 @@ class Role < ActiveRecord::Base
     anonymous_role
   end
 
+  # options can have following keys
+  # :search - scoped search applied to built filters
+  def add_permissions(permissions, options = {})
+    permissions = Array(permissions)
+    search = options.delete(:search)
+
+    collection = Permission.where(:name => permissions).all
+    raise ArgumentError, 'some permissions were not found' if collection.size != permissions.size
+
+    collection.group_by(&:resource_type).each do |resource_type, grouped_permissions|
+      filter = self.filters.build(:search => search)
+      filter.role ||= self
+
+      grouped_permissions.each do |permission|
+        filtering = filter.filterings.build
+        filtering.filter = filter
+        filtering.permission = permission
+      end
+    end
+  end
+
+  def add_permissions!(*args)
+    add_permissions(*args)
+    save!
+  end
+
 private
   def allowed_permissions
-    @allowed_permissions ||= permissions + Foreman::AccessControl.public_permissions.collect {|p| p.name}
+    @allowed_permissions ||= permission_names + Foreman::AccessControl.public_permissions.map(&:name)
   end
 
   def allowed_actions
diff --git a/app/models/setting/general.rb b/app/models/setting/general.rb
index e6a69296f..13f6a65e5 100644
--- a/app/models/setting/general.rb
+++ b/app/models/setting/general.rb
@@ -13,6 +13,7 @@ class Setting::General < Setting
         self.set('foreman_url', N_("URL where your Foreman instance is reachable (see also Provisioning > unattended_url)"), "#{protocol}://#{Facter.fqdn}"),
         self.set('email_reply_address', N_("Email reply address for emails that Foreman is sending"), "Foreman-noreply@#{domain}"),
         self.set('entries_per_page', N_("Number of records shown per page in Foreman"), 20),
+        self.set('fix_db_cache', N_('Fix DB cache on next Foreman restart'),false),
         self.set('authorize_login_delegation', N_("Authorize login delegation with REMOTE_USER environment variable"),false),
         self.set('authorize_login_delegation_api', N_("Authorize login delegation with REMOTE_USER environment variable for API calls too"),false),
         self.set('idle_timeout', N_("Log out idle users after a certain number of minutes"),60),
diff --git a/app/models/smart_proxy.rb b/app/models/smart_proxy.rb
index 3e3adc289..e0a45af7a 100644
--- a/app/models/smart_proxy.rb
+++ b/app/models/smart_proxy.rb
@@ -1,5 +1,5 @@
 class SmartProxy < ActiveRecord::Base
-  include Authorization
+  include Authorizable
   include Taxonomix
   audited :allow_mass_assignment => true
 
@@ -22,6 +22,8 @@ class SmartProxy < ActiveRecord::Base
   # There should be no problem with associating features before the proxy is saved as the whole operation is in a transaction
   before_save :sanitize_url, :associate_features
 
+  scoped_search :on => :name, :complete_value => :true
+
   # with proc support, default_scope can no longer be chained
   # include all default scoping here
   default_scope lambda {
@@ -30,12 +32,6 @@ class SmartProxy < ActiveRecord::Base
     end
   }
 
-  scope :my_proxies, lambda {
-    user       = User.current
-    conditions = user.admin? || user.allowed_to?({ :controller => :smart_proxy, :action => :index }) ? {} : '1 = 0'
-    where(conditions)
-  }
-
   Feature.name_map.each { |f, v| scope "#{f}_proxies".to_sym, where(:features => { :name => v }).joins(:features) }
 
   def hostname
diff --git a/app/models/subnet.rb b/app/models/subnet.rb
index b94cbed80..2ac65fdea 100644
--- a/app/models/subnet.rb
+++ b/app/models/subnet.rb
@@ -1,6 +1,6 @@
 require 'ipaddr'
 class Subnet < ActiveRecord::Base
-  include Authorization
+  include Authorizable
   include Taxonomix
   audited :allow_mass_assignment => true
 
diff --git a/app/models/taxonomy.rb b/app/models/taxonomy.rb
index c2b344e39..6bbf6a5b7 100644
--- a/app/models/taxonomy.rb
+++ b/app/models/taxonomy.rb
@@ -1,5 +1,6 @@
 class Taxonomy < ActiveRecord::Base
-  include Authorization
+  include Authorizable
+
   include NestedAncestryCommon
 
   serialize :ignore_types, Array
diff --git a/app/models/template_combination.rb b/app/models/template_combination.rb
index cf1c11e92..090eaa9c5 100644
--- a/app/models/template_combination.rb
+++ b/app/models/template_combination.rb
@@ -5,8 +5,4 @@ class TemplateCombination < ActiveRecord::Base
   validates :environment_id, :uniqueness => {:scope => [:hostgroup_id, :config_template_id]}
   validates :hostgroup_id, :uniqueness => {:scope => [:environment_id, :config_template_id]}
 
-  # process_resource_error relies on presence of this method
-  def permission_failed?
-    false
-  end
 end
diff --git a/app/models/user.rb b/app/models/user.rb
index e9fd8baea..c8e0fc88e 100644
--- a/app/models/user.rb
+++ b/app/models/user.rb
@@ -1,7 +1,7 @@
 require 'digest/sha1'
 
 class User < ActiveRecord::Base
-  include Authorization
+  include Authorizable
   include Foreman::ThreadSession::UserModel
   include Taxonomix
   audited :except => [:last_login_on, :password, :password_hash, :password_salt, :password_confirmation], :allow_mass_assignment => true
@@ -16,10 +16,16 @@ class User < ActiveRecord::Base
   has_many :auditable_changes, :class_name => '::Audit', :as => :user
   has_many :usergroup_member, :as => :member, :dependent => :destroy
   has_many :usergroups, :through => :usergroup_member
+  has_many :cached_usergroup_members
+  has_many :cached_usergroups, :through => :cached_usergroup_members, :source => :usergroup
   has_many :direct_hosts, :as => :owner, :class_name => "Host"
   has_and_belongs_to_many :notices, :join_table => 'user_notices'
-  has_many :user_roles, :dependent => :destroy
-  has_many :roles, :through => :user_roles
+  has_many :user_roles, :dependent => :destroy, :foreign_key => 'owner_id', :conditions => {:owner_type => self.to_s}
+  has_many :roles, :through => :user_roles, :dependent => :destroy
+  has_many :cached_user_roles, :dependent => :destroy
+  has_many :cached_roles, :through => :cached_user_roles, :source => :role, :uniq => true
+  has_many :filters, :through => :cached_roles
+  has_many :permissions, :through => :filters
   has_and_belongs_to_many :compute_resources, :join_table => "user_compute_resources"
   has_and_belongs_to_many :domains,           :join_table => "user_domains"
   has_many :user_hostgroups, :dependent => :destroy
@@ -28,8 +34,16 @@ class User < ActiveRecord::Base
   has_many :facts, :through => :user_facts, :source => :fact_name
   attr_name :login
 
-  scope :except_admin, lambda { where(:admin => false) }
-  scope :only_admin, lambda { where(:admin => true) }
+  scope :except_admin, lambda {
+    includes(:cached_usergroups).
+        where(["(#{self.table_name}.admin = ? OR #{self.table_name}.admin IS NULL) AND " +
+                   "(#{Usergroup.table_name}.admin = ? OR #{Usergroup.table_name}.admin IS NULL)",
+               false, false])
+  }
+  scope :only_admin, lambda {
+    includes(:cached_usergroups).
+        where(["#{self.table_name}.admin = ? OR #{Usergroup.table_name}.admin = ?", true, true])
+  }
 
   accepts_nested_attributes_for :user_facts, :reject_if => lambda { |a| a[:criteria].blank? }, :allow_destroy => true
 
@@ -57,9 +71,10 @@ class User < ActiveRecord::Base
   scoped_search :on => :firstname, :complete_value => :true
   scoped_search :on => :lastname, :complete_value => :true
   scoped_search :on => :mail, :complete_value => :true
-  scoped_search :on => :admin, :complete_value => {:true => true, :false => false}
+  scoped_search :on => :admin, :complete_value => { :true => true, :false => false }, :ext_method => :search_by_admin
   scoped_search :on => :last_login_on, :complete_value => :true, :only_explicit => true
   scoped_search :in => :roles, :on => :name, :rename => :role, :complete_value => true
+  scoped_search :in => :cached_usergroups, :on => :name, :rename => :usergroup, :complete_value => true
 
   default_scope lambda {
     with_taxonomy_scope do
@@ -67,6 +82,35 @@ class User < ActiveRecord::Base
     end
   }
 
+  def can?(permission, subject = nil)
+    if self.admin?
+      true
+    else
+      @authorizer ||= Authorizer.new(self)
+      @authorizer.can?(permission, subject)
+    end
+  end
+
+  def self.search_by_admin(key, operator, value)
+    value      = value == 'true'
+    value      = !value if operator == '<>'
+    conditions = [self.table_name, Usergroup.table_name].map do |base|
+      "(#{base}.admin = ?" + (value ? ')' : " OR #{base}.admin IS NULL)")
+    end
+    conditions = conditions.join(value ? ' OR ' : ' AND ')
+
+    {
+        :include    => :cached_usergroups,
+        :conditions => sanitize_sql_for_conditions([conditions, value, value])
+    }
+  end
+
+  # note that if you assign user new usergroups which change the admin flag you must save
+  # the record before #admin? will reflect this
+  def admin?
+    read_attribute(:admin) || cached_usergroups.any?(&:admin?)
+  end
+
   def to_label
     (firstname.present? || lastname.present?) ? "#{firstname} #{lastname}" : login
   end
@@ -195,7 +239,7 @@ class User < ActiveRecord::Base
       action[:controller] = action[:controller].to_s.gsub(/::/, "_").sub(/^\//,'').underscore
       return true if editing_self?(action)
     end
-    roles.detect {|role| role.allowed_to?(action)}.present?
+    cached_roles.detect {|role| role.allowed_to?(action)}.present?
   end
 
   def logged?
diff --git a/app/models/user_role.rb b/app/models/user_role.rb
index d78d7c549..d2364ae43 100644
--- a/app/models/user_role.rb
+++ b/app/models/user_role.rb
@@ -16,9 +16,53 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 
 class UserRole < ActiveRecord::Base
-  belongs_to :user
+  belongs_to :owner, :polymorphic => true
   belongs_to :role
 
+  has_many :cached_user_roles, :dependent => :destroy
+
   validates :role_id, :presence => true
-  validates :user_id, :presence => true, :uniqueness => {:scope => :role_id, :message => N_("has this role already")}
+  validates :owner_id, :presence => true, :uniqueness => {:scope => [:role_id, :owner_type],
+                                                          :message => N_("has this role already")}
+  def user_role?
+    self.owner_type == 'User'
+  end
+
+  def user_group_role?
+    self.owner_type == 'Usergroup'
+  end
+
+  before_save :remove_cache!
+  after_save :cache_user_roles!
+  before_destroy :remove_cache!
+
+  private
+
+  def remove_cache!
+    cached_user_roles.destroy_all
+  end
+
+  def cache_user_roles!
+    if self.user_role?
+      built = build_user_role_cache
+    elsif self.user_group_role?
+      built = build_user_group_role_cache(self.owner)
+    else
+      raise 'unknown UserRole owner type'
+    end
+
+    built.all?(&:save!)
+  end
+
+  def build_user_role_cache
+    [ self.cached_user_roles.build(:user => owner, :role => role) ]
+  end
+
+  def build_user_group_role_cache(owner)
+    cache = []
+    cache += owner.users.map { |m| self.cached_user_roles.build(:user => m, :role => role) }
+    cache += owner.usergroups.map { |g| build_user_group_role_cache(g) }
+    cache.flatten
+  end
+
 end
diff --git a/app/models/usergroup.rb b/app/models/usergroup.rb
index 1ee38e41d..84757012e 100644
--- a/app/models/usergroup.rb
+++ b/app/models/usergroup.rb
@@ -1,10 +1,19 @@
 class Usergroup < ActiveRecord::Base
-  include Authorization
   audited :allow_mass_assignment => true
+  include Authorizable
+
+  has_many :user_roles, :dependent => :destroy, :foreign_key => 'owner_id', :conditions => {:owner_type => self.to_s}
+  has_many :roles, :through => :user_roles, :dependent => :destroy
 
   has_many :usergroup_members, :dependent => :destroy
-  has_many :users,      :through => :usergroup_members, :source => :member, :source_type => 'User'
-  has_many :usergroups, :through => :usergroup_members, :source => :member, :source_type => 'Usergroup'
+  has_many :users,      :through => :usergroup_members, :source => :member, :source_type => 'User', :dependent => :destroy
+  has_many :usergroups, :through => :usergroup_members, :source => :member, :source_type => 'Usergroup', :dependent => :destroy
+
+  has_many :cached_usergroup_members
+  has_many :usergroup_parents, :dependent => :destroy, :foreign_key => 'member_id',
+           :conditions => "member_type = 'Usergroup'", :class_name => 'UsergroupMember'
+  has_many :parents,    :through => :usergroup_parents, :source => :usergroup, :dependent => :destroy
+
 
   has_many_hosts :as => :owner
   validates :name, :uniqueness => true
diff --git a/app/models/usergroup_member.rb b/app/models/usergroup_member.rb
index 6fea6dd53..8b1f9d319 100644
--- a/app/models/usergroup_member.rb
+++ b/app/models/usergroup_member.rb
@@ -2,4 +2,112 @@ class UsergroupMember < ActiveRecord::Base
   belongs_to :member, :polymorphic => true
   belongs_to :usergroup
 
+  before_validation :ensure_no_cycle
+  before_update :remove_old_cache_for_old_record
+  after_save :add_new_cache
+  after_destroy :remove_old_cache
+
+  scope :user_memberships, lambda { where("member_type = 'User'") }
+  scope :usergroup_memberships, lambda { where("member_type = 'Usergroup'") }
+
+  private
+
+  def ensure_no_cycle
+    current = UsergroupMember.usergroup_memberships
+    EnsureNoCycle.new(current, :usergroup_id, :member_id).ensure(self)
+  end
+
+  def add_new_cache
+    find_all_affected_users.each do |user|
+      find_all_user_roles.each do |user_role|
+        CachedUserRole.create!(:user      => user, :role => user_role.role,
+                               :user_role => user_role)
+      end
+
+      find_all_usergroups.each do |group|
+        CachedUsergroupMember.create!(:user => user, :usergroup => group)
+      end
+    end
+  end
+
+  def remove_old_cache_for_old_record
+    klass = member_type_changed? ? self.member_type_was.constantize : self.member_type.constantize
+    users = member_id_changed? ? find_all_affected_users_for(klass.find(member_id_was)).flatten : find_all_affected_users
+    roles = usergroup_id_changed? ? find_all_user_roles_for(Usergroup.find(usergroup_id_was)).flatten : find_all_user_roles
+
+    drop_role_cache(users, roles)
+
+    groups = usergroup_id_changed? ? find_all_usergroups_for(Usergroup.find(usergroup_id_was)).flatten : find_all_usergroups
+    drop_group_cache(users, groups)
+  end
+
+  def remove_old_cache
+    users = find_all_affected_users
+    drop_role_cache(users, find_all_user_roles)
+    drop_group_cache(users, find_all_usergroups)
+
+    # we need to recache records that may got deleted unintentionally
+    # we can't detect exact records to delete since we'd have to distinguish by whole path
+    recache_memberships
+  end
+
+  def recache_memberships
+    find_all_affected_memberships.each(&:save!)
+  end
+
+  def drop_role_cache(users, user_roles)
+    CachedUserRole.where(:user_role_id => user_roles.map(&:id), :user_id => users.map(&:id)).destroy_all
+  end
+
+  def drop_group_cache(users, groups)
+    CachedUsergroupMember.where(:user_id => users.map(&:id), :usergroup_id => groups.map(&:id)).destroy_all
+  end
+
+  def find_all_affected_users
+    find_all_affected_users_for(member).flatten.uniq
+  end
+
+  def find_all_affected_users_for(member)
+    if member.is_a?(User)
+      [member]
+    elsif member.is_a?(Usergroup)
+      [member.users + member.usergroups.map { |g| find_all_affected_users_for(g) }]
+    else
+      raise ArgumentError, "Unknown member type #{member}"
+    end
+  end
+
+  def find_all_affected_memberships
+    [
+        find_all_affected_memberships_for(member, :usergroups),
+        find_all_affected_memberships_for(usergroup, :parents)
+    ].flatten
+  end
+
+  def find_all_affected_memberships_for(member, direction = :usergroups)
+    if member.is_a?(User)
+      [ member.usergroup_member ]
+    elsif member.is_a?(Usergroup)
+      [ member.usergroup_members.user_memberships +
+           member.send(direction).map { |g| find_all_affected_memberships_for(g, direction) } ]
+    else
+      raise ArgumentError, "Unknown member type #{member}"
+    end
+  end
+
+  def find_all_user_roles
+    find_all_user_roles_for(usergroup).flatten
+  end
+
+  def find_all_user_roles_for(usergroup)
+    usergroup.user_roles + usergroup.parents.map { |g| find_all_user_roles_for(g) }
+  end
+
+  def find_all_usergroups
+    find_all_usergroups_for(usergroup).flatten
+  end
+
+  def find_all_usergroups_for(usergroup)
+    [ usergroup ] + usergroup.parents.map { |p| find_all_usergroups_for(p) }
+  end
 end
